]> git.donarmstrong.com Git - debhelper.git/blobdiff - Debian/Debhelper/Dh_Lib.pm
r1700: * Make dh_gconf postinst more portable.
[debhelper.git] / Debian / Debhelper / Dh_Lib.pm
index a909335bec72ee5c6e4d2a78860896bc36ec69f8..c64f6433e42922f4a15a200f8a848a9561543b8c 100644 (file)
@@ -11,8 +11,10 @@ use Exporter;
 use vars qw(@ISA @EXPORT %dh);
 @ISA=qw(Exporter);
 @EXPORT=qw(&init &doit &complex_doit &verbose_print &error &warning &tmpdir
-           &pkgfile &pkgext &isnative &autoscript &filearray &GetPackages
-           &basename &dirname &xargs %dh &compat &addsubstvar &delsubstvar);
+           &pkgfile &pkgext &pkgfilename &isnative &autoscript &filearray
+           &filedoublearray &getpackages &basename &dirname &xargs %dh
+           &compat &addsubstvar &delsubstvar &excludefile &is_udeb
+           &udeb_filename);
 
 my $max_compat=4;
 
@@ -42,6 +44,23 @@ sub init {
                %dh=Debian::Debhelper::Dh_Getopt::parseopts();
        }
 
+       # Another way to set excludes.
+       if (exists $ENV{DH_ALWAYS_EXCLUDE} && length $ENV{DH_ALWAYS_EXCLUDE}) {
+               push @{$dh{EXCLUDE}}, split(":", $ENV{DH_ALWAYS_EXCLUDE});
+       }
+       
+       # Generate EXCLUDE_FIND.
+       if ($dh{EXCLUDE}) {
+               $dh{EXCLUDE_FIND}='';
+               foreach (@{$dh{EXCLUDE}}) {
+                       my $x=$_;
+                       $x=escape_shell($x);
+                       $x=~s/\./\\./g;
+                       $dh{EXCLUDE_FIND}.="-regex .*$x.* -or ";
+               }
+               $dh{EXCLUDE_FIND}=~s/ -or $//;
+       }
+       
        # Check to see if DH_VERBOSE environment variable was set, if so,
        # make sure verbose is on.
        if (defined $ENV{DH_VERBOSE} && $ENV{DH_VERBOSE} ne "") {
@@ -54,10 +73,13 @@ sub init {
                $dh{NO_ACT}=1;
        }
 
+       my @allpackages=getpackages();
        # Get the name of the main binary package (first one listed in
-       # debian/control).
-       my @allpackages=GetPackages();
-       $dh{MAINPACKAGE}=$allpackages[0];
+       # debian/control). Only if the main package was not set on the
+       # command line.
+       if (! exists $dh{MAINPACKAGE} || ! defined $dh{MAINPACKAGE}) {
+               $dh{MAINPACKAGE}=$allpackages[0];
+       }
 
        # Check if packages to build have been specified, if not, fall back to
        # the default, doing them all.
@@ -78,11 +100,17 @@ sub init {
        # This package gets special treatement: files and directories specified on
        # the command line may affect it.
        $dh{FIRSTPACKAGE}=${$dh{DOPACKAGES}}[0];
+
+       # If no error handling function was specified, just propigate
+       # errors out.
+       if (! exists $dh{ERROR_HANDLER} || ! defined $dh{ERROR_HANDLER}) {
+               $dh{ERROR_HANDLER}='exit $?';
+       }
 }
 
 # Pass it an array containing the arguments of a shell command like would
 # be run by exec(). It turns that into a line like you might enter at the
-# shell, escaping metacharacters and quoting qrguments that contain spaces.
+# shell, escaping metacharacters and quoting arguments that contain spaces.
 sub escape_shell {
        my @args=@_;
        my $line="";
@@ -91,12 +119,12 @@ sub escape_shell {
                if ($word=~/\s/) {
                        # Escape only a few things since it will be quoted.
                        # Note we use double quotes because you cannot
-                       # escape ' in qingle quotes, while " can be escaped
+                       # escape ' in single quotes, while " can be escaped
                        # in double.
                        # This does make -V"foo bar" turn into "-Vfoo bar",
                        # but that will be parsed identically by the shell
                        # anyway..
-                       $word=~s/([\n`\$"\\])/\$1/g;
+                       $word=~s/([\n`\$"\\])/\\$1/g;
                        push @ret, "\"$word\"";
                }
                else {
@@ -118,7 +146,8 @@ sub doit {
        verbose_print(escape_shell(@_));
 
        if (! $dh{NO_ACT}) {
-               system(@_) == 0 || error("command returned error code");
+               my $ret=system(@_);
+               $ret == 0 || error("command returned error code $ret");
        }
 }
 
@@ -199,7 +228,8 @@ sub warning {
 # Returns the basename of the argument passed to it.
 sub basename {
        my $fn=shift;
-       
+
+       $fn=~s/\/$//g; # ignore trailing slashes
        $fn=~s:^.*/(.*?)$:$1:;
        return $fn;
 }
@@ -208,6 +238,7 @@ sub basename {
 sub dirname {
        my $fn=shift;
        
+       $fn=~s/\/$//g; # ignore trailing slashes
        $fn=~s:^(.*)/.*?$:$1:;
        return $fn;
 }
@@ -223,9 +254,15 @@ sub compat {
        }
        elsif (-e 'debian/compat') {
                # Try the file..
-               open (COMPAT_IN, "debian/compat") || die "debian/compat: $!";
-               $c=<COMPAT_IN>;
-               chomp $c;
+               open (COMPAT_IN, "debian/compat") || error "debian/compat: $!";
+               my $l=<COMPAT_IN>;
+               if (! defined $l || ! length $l) {
+                       warning("debian/compat is empty, assuming level $c");
+               }
+               else {
+                       chomp $l;
+                       $c=$l
+               }
        }
 
        if ($c > $max_compat) {
@@ -259,10 +296,18 @@ sub tmpdir {
 #   * debian/package.filename.buildarch
 #   * debian/package.filename
 #   * debian/file (if the package is the main package)
+# If --name was specified then tonly the first two are tried, and they must
+# have the name after the pacage name:
+#   * debian/package.name.filename.buildarch
+#   * debian/package.name.filename
 sub pkgfile {
        my $package=shift;
        my $filename=shift;
 
+       if (defined $dh{NAME}) {
+               $filename="$dh{NAME}.$filename";
+       }
+       
        if (-f "debian/$package.$filename.".buildarch()) {
                return "debian/$package.$filename.".buildarch();
        }
@@ -278,7 +323,7 @@ sub pkgfile {
 }
 
 # Pass it a name of a binary package, it returns the name to prefix to files
-# in debian for this package.
+# in debian/ for this package.
 sub pkgext {
        my $package=shift;
 
@@ -288,6 +333,18 @@ sub pkgext {
        return "$package.";
 }
 
+# Pass it the name of a binary package, it returns the name to install
+# files by in eg, etc. Normally this is the same, but --name can override
+# it.
+sub pkgfilename {
+       my $package=shift;
+
+       if (defined $dh{NAME}) {
+               return $dh{NAME};
+       }
+       return $package;
+}
+
 # Returns 1 if the package is a native debian package, null otherwise.
 # As a side effect, sets $dh{VERSION} to the version of this package.
 {
@@ -368,7 +425,7 @@ sub delsubstvar {
        my $substvarfile="debian/${ext}substvars";
 
        if (-e $substvarfile) {
-               complex_doit("grep -v '^${substvar}=' $substvarfile > $substvarfile.new || true");
+               complex_doit("grep -s -v '^${substvar}=' $substvarfile > $substvarfile.new || true");
                doit("mv", "$substvarfile.new","$substvarfile");
        }
 }
@@ -385,14 +442,14 @@ sub addsubstvar {
        my $ext=pkgext($package);
        my $substvarfile="debian/${ext}substvars";
        my $str=$deppackage;
-       $str.=" ($verinfo)" if length $verinfo;
+       $str.=" ($verinfo)" if defined $verinfo && length $verinfo;
 
        # Figure out what the line will look like, based on what's there
        # now, and what we're to add or remove.
        my $line="";
        if (-e $substvarfile) {
                my %items;
-               open(SUBSTVARS_IN, "$substvarfile") || die "read $substvarfile: $!";
+               open(SUBSTVARS_IN, "$substvarfile") || error "read $substvarfile: $!";
                while (<SUBSTVARS_IN>) {
                        chomp;
                        if (/^\Q$substvar\E=(.*)/) {
@@ -415,21 +472,27 @@ sub addsubstvar {
        }
 
        if (length $line) {
-                complex_doit("echo '${substvar}=$line' >> $substvarfile");
+                complex_doit("(grep -s -v ${substvar} $substvarfile; echo ".escape_shell("${substvar}=$line").") > $substvarfile.new");
+                doit("mv", "$substvarfile.new", $substvarfile);
+       }
+       else {
+               delsubstvar($package,$substvar);
        }
 }
 
-# Reads in the specified file, one word at a time, and returns an array of
-# the result. If a value is passed in as the second parameter, then glob
+# Reads in the specified file, one line at a time. splits on words, 
+# and returns an array of arrays of the contents.
+# If a value is passed in as the second parameter, then glob
 # expansion is done in the directory specified by the parameter ("." is
 # frequently a good choice).
-sub filearray {
+sub filedoublearray {
        my $file=shift;
        my $globdir=shift;
 
        my @ret;
        open (DH_FARRAY_IN, $file) || error("cannot read $file: $1");
        while (<DH_FARRAY_IN>) {
+               my @line;
                # Only do glob expansion in v3 mode.
                #
                # The tricky bit is that the glob expansion is done
@@ -438,18 +501,34 @@ sub filearray {
                if (defined $globdir && ! compat(2)) {
                        for (map { glob "$globdir/$_" } split) {
                                s#^$globdir/##;
-                               push @ret, $_;
+                               push @line, $_;
                        }
                }
                else {
-                       push @ret, split;
+                       @line = split;
                }
+               push @ret, [@line];
        }
        close DH_FARRAY_IN;
        
        return @ret;
 }
 
+# Reads in the specified file, one word at a time, and returns an array of
+# the result. Can do globbing as does filedoublearray.
+sub filearray {
+       return map { @$_ } filedoublearray(@_);
+}
+
+# Passed a filename, returns true if -X says that file should be excluded.
+sub excludefile {
+        my $filename = shift;
+        foreach my $f (@{$dh{EXCLUDE}}) {
+                return 1 if $filename =~ /\Q$f\E/;
+        }
+        return 0;
+}
+
 # Returns the build architecture. (Memoized)
 {
        my $arch;
@@ -457,7 +536,7 @@ sub filearray {
        sub buildarch {
                return $arch if defined $arch;
 
-               $arch=`dpkg --print-architecture` || error($!);
+               $arch=`dpkg-architecture -qDEB_HOST_ARCH 2>/dev/null` || error($!);
                chomp $arch;
                return $arch;
        }
@@ -467,8 +546,14 @@ sub filearray {
 # Must pass "arch" or "indep" or "same" to specify arch-dependant or
 # -independant or same arch packages. If nothing is specified, returns all
 # packages.
-sub GetPackages {
+# As a side effect, populates %package_arches and %package_types with the
+# types of all packages (not only those returned).
+my (%package_types, %package_arches);
+sub getpackages {
        my $type=shift;
+
+       %package_types=();
+       %package_arches=();
        
        $type="" if ! defined $type;
        
@@ -480,6 +565,7 @@ sub GetPackages {
 
        my $package="";
        my $arch="";
+       my $package_type;
        my @list=();
        my %seen;
        open (CONTROL, 'debian/control') ||
@@ -496,12 +582,20 @@ sub GetPackages {
                        else {
                                error("debian/control has a duplicate entry for $package");
                        }
+                       $package_type="deb";
                }
                if (/^Architecture:\s*(.*)/) {
                        $arch=$1;
                }
+               if (/^X[BC]*-Package-Type:\s*(.*)/) {
+                       $package_type=$1;
+               }
                
                if (!$_ or eof) { # end of stanza.
+                       if ($package) {
+                               $package_types{$package}=$package_type;
+                               $package_arches{$package}=$arch;
+                       }
                        if ($package &&
                            (($type eq 'indep' && $arch eq 'all') ||
                             ($type eq 'arch' && $arch ne 'all') ||
@@ -518,4 +612,20 @@ sub GetPackages {
        return @list;
 }
 
+sub is_udeb {
+       my $package=shift;
+       
+       return $package_types{$package} eq 'udeb';
+}
+
+sub udeb_filename {
+       my $package=shift;
+       
+       my $filearch=$package_arches{$package} eq 'all' ? "all" : buildarch();
+       isnative($package); # side effect
+       my $version=$dh{VERSION};
+       $version=~s/^[0-9]+://; # strip any epoch
+       return "${package}_${version}_$filearch.udeb";
+}
+
 1